//******************************************************************************
//!
//! @file $Id: mc_drv.c 1137 2008-04-17 16:35:06Z raubree $
//!
//! Copyright (c) 2007 Atmel.
//!
//! @brief ײ  : Init, PWMȂ
//!
//! @todo
//! @bug
//******************************************************************************

//_____ ݸٰ _______________________________________________________________

#include "config.h"

#include "mc_drv.h"
#include "mc_interface.h"
#include "mc_control.h"

#include "psc\psc_drv.h"
#include "adc\adc_drv.h"
#include "dac\dac_drv.h"
#include "pll\pll_drv.h"
#include "comparator\comparator_drv.h"

#define PSWAP0		2
#define PSWAP1		3
#define PSWAP2		4

Bool overcurrent =	FALSE;

U8 count = 1;						// countϐn̎ł̕ϑxvZɎgp܂B
U16 average = 0;
static U8 ovf_timer = 0;			// ovf_timerϐ8ޯČv16ޯČvЭڰĂ̂Ɏgp܂B

static Bool inrush_mask_flag = FALSE;
static U16 inrush_delay = 0;

Bool g_mc_read_enable = FALSE;		// xǂݍ݉׸
Bool g_tick = FALSE;				//!< ̎l̐Ɏgp

Bool current_EOC = FALSE;			// ϊI׸

static char State = CONV_INIT;		// A/Dϊv敔̏
static char ADC_State = FREE;		// BUSY=sAFREE=񑖍s(~)

/******************************************************************************/
/******************************************************************************/
/*		ʰ޳														  */
/******************************************************************************/
/******************************************************************************/


//! @brief mc_init_HW : ʰ޳
//! @post ʰ޳̏
void mc_init_HW(void)
{
  // (PSCo͂Ɏgp)o݌`Ԑݒ
  // PD0UH, PB7UL
  // PC0VH, PB6VL
  // PB0WH, PB1WL

  // MOS-FET쓮ɑ΂x(Low)o
  PORTB &= ~(1<<PORTB7 | 1<<PORTB6 | 1<<PORTB1 | 1<<PORTB0);
  PORTC &= ~(1<<PORTC0);
  PORTD &= ~(1<<PORTD0);

  // ߰B :
  DDRB = (1<<DDB7)|(1<<DDB6)|(1<<DDB1)|(1<<DDB0);
  // ߰C :
  DDRC = (1<<DDC0);
  // ߰D :
  DDRD = (1<<DDD0);

  Init_PC7();	/* PC7͉ߓd̕\Ɏgp܂B */

  // 1Ɋւ޼ٓ͂֎~
  // rp޼ٓ͂͋֎~܂B
  DIDR1 = (1<<ADC9D)|(1<<ADC8D);

  // VrefI
//  init_vref_source ();

//  init_adc();
  Adc_config();
  Amp1_config();

  //  : PWM̑OD/AϊƉߓd
  // D/Aϊ͉ߓd(rpd)Ɏgp܂B
  Dac_config();
  /* ߓdِݒ */
  Dac_set_8_bits(IMAX);
    
  mc_init_timer0();
  mc_init_timer1();

  Comp_0_config();
  Comp_1_config();
  Comp_2_config();
  
  // ΰيmH2ł̕ωoPCINT14gp
  PCMSK1 = (1<<PCINT14);
  PCICR = (1<<PCIE1);

//  Start_pll_32_mega();	// 32MHz PLLo͎gpPLLJn
  Start_pll_64_mega();		// 64MHz PLLo͎gpPLLJn
  Wait_pll_ready();

  // => PSCx_Init(Period_Half, Dutyx0_Half, Synchro, Dutyx1_Half)
  PSC_Init();
}

//! @brief PSC : config.hł̐ݒɏ]PSC
void PSC_Init (void)
{
  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);
  Psc_set_register_RB(RB_VAL);

  Psc_config();

  Psc_config_input_0(PSC_OVERLAP_ENABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_1(PSC_OVERLAP_ENABLE,\
					 PSC_USE_COMPARATOR,\
					 PSC_USE_HIGH_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  Psc_config_input_2(PSC_OVERLAP_ENABLE,\
					 PSC_USE_PIN,\
					 PSC_USE_LOW_LEVEL,\
					 PSC_INPUT_FILTER_ENABLE,\
					 PSC_SYNCHRONOUS_OUTPUT_CONTROL,\
					 PSC_INPUT_NO_ACTION);

  PIFR = (1<<PEV2)|(1<<PEV1)|(1<<PEV0)|(1<<PEOP);
  PIM = (1<<PEVE1);

  Psc_run();
}

/***************************************************************************/
/***************************************************************************/
/*		d@̑(])pS֐									   */
/***************************************************************************/
/***************************************************************************/

/**
* @brief	ΰيm̒l(1`6)擾
* @param	unsigned char(ΰيm̒l)Ԃ܂B
* @pre		߰PBPĎ`Ԑݒ
* @post		ʒuɐVl
*/
Hall_Position mc_get_hall(void)
{
  return HALL_SENSOR_VALUE();
}

/**
 * @brief	O (ΰيmAAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_A()
__interrupt void mc_hall_a(void)
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
  // ΰيmA̗オ[ł̐葬x
  if (PIND&(1<<PORTD7))
  {
	mc_estimation_speed();
	g_mc_read_enable=FALSE;		// ǂݍ1ҋ@ݒ
  }
  else
  {
	g_mc_read_enable=TRUE;
  }
}

/**
 * @brief	O (ΰيmBAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_B()
__interrupt void mc_hall_b(void)
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
}

 /**
 * @brief	O (ΰيmCAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#pragma vector = HALL_C()
__interrupt void mc_hall_c(void)
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
}

/**
* @brief	JԂɂČvZꂽlɏ]PSCޭè ْlݒ
*/
void mc_duty_cycle(U8 level)
{
  U8 duty;
  duty = level;

#if ((CURRENT_DECAY == SLOW_DECAY_SYNCHRONOUS)||(CURRENT_DECAY == FAST_DECAY_SYNCHRONOUS))
  U8 dutydt;	/* َԕtޭè */
  if (duty >= DEADTIME) dutydt = duty - DEADTIME;
#endif

  Psc_lock();

  // Duty=  0ޭè    0%
  // Duty=255ޭè  100%
 
#if (CURRENT_DECAY == FAST_DECAY)
  Psc_set_module_A(duty,A_RA_VAL,duty);
  Psc_set_module_B(duty,B_RA_VAL,duty);
  Psc_set_module_C(duty,C_RA_VAL,duty);
#else
#if ((CURRENT_DECAY == SLOW_DECAY_SYNCHRONOUS)||(CURRENT_DECAY == FAST_DECAY_SYNCHRONOUS))
  Psc_set_module_A(duty,A_RA_VAL,dutydt);
  Psc_set_module_B(duty,B_RA_VAL,dutydt);
  Psc_set_module_C(duty,C_RA_VAL,dutydt);
#else
  Psc_set_module_A(duty,A_RA_VAL,0);
  Psc_set_module_B(duty,B_RA_VAL,0);
  Psc_set_module_C(duty,C_RA_VAL,0);
#endif
#endif

  Psc_unlock();
}

/**
* @brief	m܂͐ʒuɏ]ďo͂ɐ؂ւ(])lݒ
*
* @param	ʒu(1`6)ƕ(FORWARD܂BACKWARD)
*/
void mc_switch_commutation(Hall_Position position)
{
  // Ő(])邽߂ɓd@擾
  char direction = mci_get_motor_direction();

  // ͎gp҂d@nAxw肪0ƈقȂꍇɂ(])܂B
  if (mci_motor_is_running())
  {
    mc_duty_cycle(mc_get_duty_cycle());
	switch(position)
	{
	// ]qʒuɏ]
	  case HS_001:  if (direction==CCW)	{Set_Q5Q2();}
					else				{Set_Q1Q6();}
					break;
	  case HS_101:  if (direction==CCW)	{Set_Q3Q2();}
					else				{Set_Q1Q4();}
					break;
	  case HS_100:  if (direction==CCW)	{Set_Q3Q6();}
					else				{Set_Q5Q4();}
					break;
	  case HS_110:  if (direction==CCW)	{Set_Q1Q6();}
					else				{Set_Q5Q2();}
					break;
	  case HS_010:  if (direction==CCW)	{Set_Q1Q4();}
					else				{Set_Q3Q2();}
					break;
	  case HS_011:  if (direction==CCW)	{Set_Q5Q4();}
					else				{Set_Q3Q6();}
					break;
	  default : break;
	}
  }
  else
  {
	Set_none();		// SOFFɂ܂B
  }
}

/******************************************************************************/
/******************************************************************************/
/*		v1 : g_tick												  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v1`Ԑݒ
 * x̍̎p250sԊuł̊𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	256s̊荞
*/
void mc_init_timer1(void)
{
  TCCR1A = 0;								// W߰ē,CTC
  TCCR1B = 1<<WGM12 | 1<<CS11 | 1<<CS10 ;	// CTC,64Ou(4s)Ŏn
  TCCR1C = 0;
  OCR1AH = 0;								// 256svl(2564-1=63)w
  OCR1AL = 63;
  TIMSK1=(1<<OCIE1A);						// rAv荞݋
}

/**
  * @brief	JԂJn(main.c)
  * @pre	v1ڼ޽̌`Ԑݒ
  * @post	g_tickmain.cŒJԂɎgp܂B
*/
#pragma vector = TIMER1_COMPA_vect
__interrupt void launch_sampling_period(void)
{
  g_tick = TRUE;
}

/******************************************************************************/
/******************************************************************************/
/*		v0 : x													  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v0`Ԑݒ
 * v0͈ꔭɊԊuԂ𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	v0
*/
void mc_init_timer0(void)
{
  TCCR0A = 0;
  TCCR0B = (1<<CS02)|(0<<CS01)|(0<<CS00);		// 256Ou(16s)Ŏn
  TIMSK0 = (1<<TOIE0);
}

/**
  * @brief	xpv0
  * @pre	v0̌`Ԑݒ
  * @post	d@x鎞Ɉ𐶐
*/
#pragma vector = TIMER0_OVF_vect
__interrupt void ovfl_timer0(void)
{
  TCNT0=0x00;
  ovf_timer++;
  // 125msɐ(])Ȃꍇ
  // 125ms=(61<<8)*8s
  if(ovf_timer >= 100)
  {
	ovf_timer = 0;
	mc_set_measured_speed(0);
	// d@ĂĒ~߂^ĂȂȂAd@͎Iɑs
	if(mci_motor_is_running())mci_retry_run();
  }
}

/**
* @brief	x
* @pre		v0̌`Ԑݒ\n config_motor.hAVERAGE_SPEED_MEASURENT̗L`
* @post		xɊւVl
*/
void mc_estimation_speed(void)
{
  U16 timer_value;
  U32 new_measured_speed;

  if (g_mc_read_enable==TRUE)
  {
	// 8ޯĕϐTCNT0l16ޯČv̼ЭڰĂɎgp܂B
	timer_value = (ovf_timer<<8) + TCNT0;

	if (timer_value == 0) {timer_value += 1 ;}				// 0Zx
	new_measured_speed = K_SPEED / timer_value;
	if(new_measured_speed > 255) new_measured_speed = 255;	// ϐOa

    #ifdef AVERAGE_SPEED_MEASUREMENT
	  // G邽߂ɕς8̎Ŏ܂B
	  average += new_measured_speed;
	  if(count >= N_SAMPLE)
	  {
		count = 1;
		mc_set_measured_speed(average >> 3);
		average = 0;
	  }
	  else count++;
	#else
	  // ωȂȂAۂ̑x擾
	  mc_set_measured_speed(new_measured_speed);
	#endif

	// v0ƕϐؾ
	TCNT0=0x00;
	ovf_timer = 0;
	g_mc_read_enable=FALSE;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		A/Dϊ͓dƉϒȒɎgp								  */
/******************************************************************************/
/******************************************************************************/

//! @brief	dl𓾂邽߂ɍ̎菇Jn
//! @pre	ƊԊuԂ̏
//! @post	ϊI׸ސݒ
#pragma vector = ADC_vect
__interrupt void ADC_end_of_conversion(void)
{
  Adc_select_channel(ADC_INPUT_GND);		/* ꂽقJ */
  if(State == CONV_POT) mc_set_potentiometer_value(Adc_get_8_bits_result());
  if(State == CONV_CURRENT) mci_store_measured_current(Adc_get_10_bits_result());
  ADC_State = FREE;
}

//! @brief	A/Dϊp̌v敔Jn
//! @post	ϒRƓd̒ľʂ擾
void mc_ADC_Scheduler(void)
{
  switch(State)
  {
  case CONV_INIT :
	ADC_State = FREE;							// A/Dϊ폀ݒ
	State = CONV_CURRENT;
	break;
  case CONV_CURRENT :							/* dA/DϊԂŁA */
	if(ADC_State == FREE)						// A/Dϊ폀ȂA
	{
	  ADC_State = BUSY;							// A/Dϊ푽Zݒ
	  State= CONV_POT;							// (ϒRA/Dϊ)ݒ
	  Adc_left_adjust_result();					// ʍݒ
	  Adc_start_conv_channel(ADC_INPUT_ISRC);	// ISRC͂ŉϒRlA/DϊJn
	}
	break;
  case CONV_POT :								/* ϒRA/DϊԂŁA */
	if(ADC_State == FREE)						// A/Dϊ폀ȂA
	{
	  ADC_State = BUSY;							// A/Dϊ푽Zݒ
	  State = CONV_CURRENT;						// (dA/Dϊ)ݒ
	  Adc_right_adjust_result();				// ʉEݒ
	  Adc_start_conv_channel(ADC_INPUT_AMP1);	// 1œdlA/DϊJn
	}
	break;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		ߓd`Ԑݒ														  */
/******************************************************************************/
/******************************************************************************/

//! @brief	̊֐̖ړI͎n̉ߓd(d)o֎~邱ƂłB\n
void mc_disable_during_inrush(void)
{
  inrush_delay = (U16) 500;
  inrush_mask_flag = TRUE;
  Disable_over_current();
}

//! @brief	̊֐̖ړI͉ߓdo֎~ɎgpxǗ邱ƂłB\n
void mc_inrush_task(void)
{ 
  if (inrush_mask_flag == TRUE)
  {
	if (inrush_delay-- == 0)
	{
	  inrush_mask_flag = FALSE;
	  Enable_over_current();
    }
  }
}

// ߓdo
#pragma vector = PSC_FAULT_vect
__interrupt void mc_overcurrent_detect(void)
{
  PIFR = (1<<PEV1);			// 荞ݗv׸މ
  overcurrent = TRUE;
  mci_stop();
}
