//*****************************************************************************
//! @file $Id: dac_drv.h 1139 2008-04-17 16:35:41Z raubree $
//!
//! Copyright (c) 2007 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! @brief ̧ق͈ȉ̊֐ײ؂̌^ϸۂ܂݂܂B
//!		   - DAC (Digital to Analog Converter)
//!		   - AT90PWMxx4p
//! ȍ~̌^"at90pwmxx4_drv.h"̧ق̂#defineKvłB
//!
//! ̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//!
//! @todo
//! @bug
//*****************************************************************************

#ifndef _DAC_DRV_H_
#define _DAC_DRV_H_

//_____ ݸٰ _______________________________________________________________

//! @defgroup DAC_module D/Aϊ핔
//! D/Aϊ핔
//! @{
//_____ ϸ ___________________________________________________________________

  //! @defgroup DAC_macros D/Aϊϸ
  //! iD/Aϊ̎gpϸ
  //! @{

	//! @defgroup Turn_on_dac D/AϊON
	//! D/AϊON
	//! @{
#define Dac_enable()						(DACON |= (1<<DAEN))
	//! @}

	//! @defgroup Turn_off_dac D/AϊOFF
	//! D/AϊOFF
	//! @{
#define Dac_disable()						(DACON &= ~(1<<DAEN))
	//! @}

	//! @defgroup DAC_alignement_configuration D/Aϊl`Ԑݒ
	//! ް`Ԑݒ
	//! @{
#define Dac_right_adjust_input()			(DACON  &= ~(1<<DALA))
#define Dac_left_adjust_input()				(DACON  |=  (1<<DALA))
	//! @}

	//! @defgroup DAC_output_configuration D/Aϊo͌`Ԑݒ
	//! D/AϊoON/OFF؂ւ
	//! @{
#define Dac_enable_output()					(DACON  |=  (1<<DAOE))
#define Dac_disable_output()				(DACON  &= ~(1<<DAOE))
	//! @}

	//! @defgroup DAC_set_input_value D/Aϊ͒lݒ
	//! ϊ͕ϊlI
	//! @{
#define Dac_set_8_bits(dac_in)				(DACH = (U8)(dac_in))
#define Dac_set_10_bits(dac_in)				(DACL = Low((U16)(dac_in)), DACH = High((U16)(dac_in)))
	//! @}

	//! @defgroup DAC_start_left D/AϊJn
	//! ̊{`ԂD/AϊJn
	//! @{
#define Dac_start_left() \
	DACON = (0<<DAATE)| /* D/AϊNޯ */ \
			(0<<DATS0)| /* D/AϊNIޯ */ \
			(1<<DALA) | /* D/Aϊޯ */ \
			(1<<DAOE) | /* D/Aϊo͋ޯ */\
			(1<<DAEN);  /* D/Aϊޯ */
	//! @}

	//! @defgroup DAC_start_right ED/AϊJn
	//! E̊{`ԂD/AϊJn
	//! @{
#define Dac_start_right() \
	DACON = (0<<DAATE)| /* D/AϊNޯ */ \
			(0<<DATS0)| /* D/AϊNIޯ */ \
			(0<<DALA) | /* D/Aϊޯ */ \
			(1<<DAOE) | /* D/Aϊo͋ޯ */\
			(1<<DAEN);  /* D/Aϊޯ */
	//! @}

	//! @defgroup Dac_set_value D/Aϊlݒ
	//! D/Aϊlݒ
	//! @{
#define Dac_set_value(param) \
	DACL = Low(param); \
	DACH = High(param);
	//! @}

#define Dac_config() \
	DACON = (DAC_AUTOTRIG_ENABLE_VALUE<<DAATE)| \
			(DAC_TRIGGER_SELECTION<<DATS0)| \
			(DAC_LEFT_ADJUST_VALUE<<DALA) | \
			(DAC_OUTPUT_ENABLE_VALUE<<DAOE) | \
			(DAC_ENABLE_VALUE<<DAEN);

//_____ ` __________________________________________________________________
#define DAC_AUTOTRIG_DISABLE	0
#define DAC_AUTOTRIG_ENABLE		1

#define DAC_TRIG_WITH_COMP0		0
#define DAC_TRIG_WITH_COMP1		1
#define DAC_TRIG_WITH_INT0		2
#define DAC_TRIG_WITH_TCCM0		3
#define DAC_TRIG_WITH_TCOVF0	4
#define DAC_TRIG_WITH_TCCM1		5
#define DAC_TRIG_WITH_TCOVF1	6
#define DAC_TRIG_WITH_TCCAP1	7

#define DAC_RIGHT_ADJUST		0
#define DAC_LEFT_ADJUST			1

#define DAC_OUTPUT_DISABLE		0
#define DAC_OUTPUT_ENABLE		1

#define DAC_DISABLE				0
#define DAC_ENABLE				1

//_____ ֐ __________________________________________________________________
  //! @defgroup DAC_low_level_functions D/Aϊʊ֐
  //! D/Aϊʊ֐
  //! @{

//! D/Aϊ`Ԑݒl`ɏ]D/Aϊ`Ԑݒ
void init_dac(void);

  //! @}
//! @}

#endif  // _DAC_DRV_H_

